src/Entity/User.php
<?php

/*
 * This file is part of the DATAtourisme project.
 * 2022
 * @author Conjecto <contact@conjecto.com>
 * SPDX-License-Identifier: GPL-3.0-or-later
 * For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 */

namespace App\Entity;

use DateTime;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Validator\Constraints as Assert;
use Gedmo\Mapping\Annotation as Gedmo;
use App\Repository\UserRepository;
use Symfony\Component\Notifier\Recipient\Recipient;
use Symfony\Component\Notifier\Recipient\RecipientInterface;
use Symfony\Component\Validator\GroupSequenceProviderInterface;

/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 * @ORM\Table(name="`user`")
 * @ORM\HasLifecycleCallbacks()
 * @Assert\GroupSequenceProvider()
 * @UniqueEntity(
 *     fields="email",
 *     message="Il existe déjà un utilisateur avec cette adresse mail"
 * )

 */
class User implements UserInterface, PasswordAuthenticatedUserInterface, GroupSequenceProviderInterface
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=180, unique=true)
     * @Assert\NotBlank()
     */
    private $email;

    /**
     * @var string
     * @ORM\Column(type="string")
     * @Assert\NotBlank()
     */
    private $role = "ROLE_USER";

    /**
     * @var string The hashed password
     * @ORM\Column(type="string")
     */
    private $password;

    /**
     * Plain password. Used for model validation. Must not be persisted.
     *
     * @var string
     */
    private $plainPassword;

    /**
     * @var bool
     * @ORM\Column(name="enabled", type="boolean")
     */
    private $enabled = false;

    /**
     * @var bool
     * @ORM\Column(name="locked", type="boolean")
     */
    private $locked = false;

    /**
     * @var bool
     * @ORM\Column(name="external", type="boolean")
     */
    private $external = false;

    /**
     * @var string
     * @ORM\Column(type="string", length=128)
     * @Assert\NotBlank()
     * @Assert\Length(max=128)
     */
    protected $lastName;

    /**
     * @var string
     * @ORM\Column(type="string", length=128)
     * @Assert\NotBlank()
     * @Assert\Length(max=128)
     */
    protected $firstName;

    /**
     * @var string
     * @ORM\Column(type="string", length=16, nullable=true)
     * @Assert\Length(max=16)
     */
    protected $phone;

    /**
     * @var string
     * @ORM\Column(type="string", length=64)
     * @Assert\Length(max=64)
     */
    protected $organization;

    /**
     * @var OrganizationType
     * @ORM\ManyToOne(targetEntity="OrganizationType", inversedBy="organizations")
     * @ORM\JoinColumn(nullable=true)
     * @Assert\NotBlank()
     */
    protected $organizationType;

    /**
     * @var array|null
     * @ORM\Column(type="simple_array", nullable=true)
     */
    protected $periodicNotifications;

    /**
     * @var array|null
     * @ORM\Column(type="json", nullable=true)
     */
    protected $thresholdNotifications;

    /**
     * @var Producer
     * @ORM\ManyToOne(targetEntity="Producer", inversedBy="users")
     * @ORM\JoinColumn(nullable=true)
     * @Assert\NotBlank(groups = {"ROLE_MANAGER", "ROLE_USER"})
     */
    private $producer;

    /**
     * @var array
     * @ORM\Column(type="json", nullable=true)
     */
    private $hasBeenCreatedBy;

    /**
     * @var User
     * @ORM\ManyToOne(targetEntity="User")
     * @ORM\JoinColumn(name="created_by", referencedColumnName="id", nullable=true, onDelete="SET NULL")
     */
    private $createdBy;

    /**
     * @var DateTime $created
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(type="datetime")
     */
    private $created;

    /**
     * @var DateTime $updated
     *
     * @Gedmo\Timestampable(on="update")
     * @ORM\Column(type="datetime")
     */
    private $updated;

    /**
     * @var DateTime $lastLogin
     *
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $lastLogin;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * A visual identifier that represents this user.
     *
     * @see UserInterface
     */
    public function getUserIdentifier(): string
    {
        return (string) $this->email;
    }

    public function getFullName(): string
    {
        return $this->firstName . ' ' . mb_strtoupper($this->lastName, 'UTF-8');
    }

    public function getReverseFullName(): string
    {
        return mb_strtoupper($this->lastName, 'UTF-8') . ' ' . $this->firstName;
    }

    /**
     * @deprecated since Symfony 5.3, use getUserIdentifier instead
     */
    public function getUsername(): string
    {
        return (string) $this->email;
    }

    /**
     * @return string
     */
    public function getFirstName(): string
    {
        return $this->firstName;
    }

    /**
     * @param string $firstName
     */
    public function setFirstName(string $firstName)
    {
        $this->firstName = $firstName;
    }

    /**
     * @return string
     */
    public function getLastName(): string
    {
        return $this->lastName;
    }

    /**
     * @param string $lastName
     */
    public function setLastName(string $lastName)
    {
        $this->lastName = $lastName;
    }

    /**
     * @return bool
     */
    public function isEnabled(): bool
    {
        return $this->enabled;
    }

    /**
     * @param bool $enabled
     */
    public function setEnabled(bool $enabled)
    {
        $this->enabled = $enabled;
    }

    /**
     * @return bool
     */
    public function isLocked(): bool
    {
        return $this->locked;
    }

    /**
     * @param bool $locked
     */
    public function setLocked(bool $locked)
    {
        $this->locked = $locked;
    }

    /**
     * @return bool
     */
    public function isExternal(): bool
    {
        return $this->external;
    }

    /**
     * @param bool $external
     */
    public function setExternal(bool $external)
    {
        $this->external = $external;
    }

    /**
     * @return string
     */
    public function getRole(): string
    {
        return $this->role ?: 'ROLE_USER';
    }

    /**
     * @param string $role
     */
    public function setRole(string $role)
    {
        $this->role = $role;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        return [$this->role];
    }

    /**
     * @see PasswordAuthenticatedUserInterface
     */
    public function getPassword(): string
    {
        return $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    /**
     * @return string
     */
    public function getPlainPassword(): ?string
    {
        return $this->plainPassword;
    }

    /**
     * @param string|null $plainPassword
     */
    public function setPlainPassword(?string $plainPassword)
    {
        $this->plainPassword = $plainPassword;
    }

    /**
     * Returning a salt is only needed, if you are not using a modern
     * hashing algorithm (e.g. bcrypt or sodium) in your security.yaml.
     *
     * @see UserInterface
     */
    public function getSalt(): ?string
    {
        return null;
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        $this->plainPassword = null;
    }

    /**
     * @return User|null
     */
    public function getCreatedBy(): ?User
    {
        return $this->createdBy;
    }

    /**
     * @param User $createdBy
     */
    public function setCreatedBy(User $createdBy): void
    {
        $this->createdBy = $createdBy;
    }

    /**
     * Get $created
     *
     * @return  DateTime
     */
    public function getCreated(): DateTime
    {
        return $this->created;
    }

    /**
     * Set $created
     *
     * @param DateTime $created
     * @return  self
     */
    public function setCreated(DateTime $created): User
    {
        $this->created = $created;

        return $this;
    }

    /**
     * Get $updated
     *
     * @return  DateTime
     */
    public function getUpdated(): Datetime
    {
        return $this->updated;
    }

    /**
     * Set $updated
     *
     * @param  DateTime  $updated  $updated
     *
     * @return  self
     */
    public function setUpdated(DateTime $updated)
    {
        $this->updated = $updated;

        return $this;
    }

    /**
     * Get $updated
     *
     * @return  DateTime
     */
    public function getLastLogin(): ?Datetime
    {
        return $this->lastLogin;
    }

    /**
     * Set $updated
     *
     * @param DateTime $lastLogin
     * @return  self
     */
    public function setLastLogin(DateTime $lastLogin)
    {
        $this->lastLogin = $lastLogin;

        return $this;
    }

    /**
     * Get the value of phone
     *
     * @return  string
     */
    public function getPhone(): ?string
    {
        return $this->phone;
    }

    /**
     * Set the value of phone
     *
     * @param  string  $phone
     *
     * @return  self
     */
    public function setPhone(string $phone)
    {
        $this->phone = $phone;

        return $this;
    }

    /**
     * Get the value of organizationName
     *
     * @return  string
     */
    public function getOrganization(): string
    {
        return $this->organization;
    }

    /**
     * Set the value of organizationName
     *

templates/_html.html.twig
{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% import "macros.html.twig" as macros %}

<!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<title>
			{%- if block('title') is defined -%}
				{{- block('title') }} | DATAtourisme
			{%- else -%}
				DATAtourisme > Plateforme qualité
			{%- endif -%}
		</title>
		<link rel="icon" type="image/x-icon" href="{{ asset('build/images/favicon.ico') }}"/>

		{%- block stylesheets -%}
			{{ encore_entry_link_tags('app') }}
		{%- endblock -%}

		{%- block javascripts -%}
			{{ encore_entry_script_tags('app') }}
		{%- endblock -%}
	</head>
	<body class="{% block body_classes %}{% endblock %}">
        {%- block body %}{% endblock -%}
        {{ macros.flashes() }}
    </body>
</html>

templates/_layout.html.twig
{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends '_html.html.twig' %}
{% import "macros.html.twig" as macros %}

{% block body_classes %}layout-top-nav{% endblock  %}

{% block body %}
    <div class="wrapper flex flex-col h-full">
        <header class="main-header">
            <nav class="navbar navbar-fixed-top">
                <div class="navbar-gouv-placeholder"></div>
                <div class="navbar-gouv-bg"></div>
                <div class="container">
                    <div class="navbar-wrapper">
                        <div class="navbar-header">
                            <div class="navbar-gouv">
                                <img src="{{ asset('build/images/logos/marianne.png') }}">
                                <img src="{{ asset('build/images/logos/minefi.png') }}">
                            </div>
                            <a href="/" class="navbar-brand">
                                <img src="{{ asset('build/images/logos/datatourisme-200-inversed.png') }}">
                            </a>
                            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar-collapse">
                                <i class="fa fa-bars"></i>
                            </button>
                        </div>
                        <!-- Collect the nav links, forms, and other content for toggling -->
                        <div class="collapse navbar-collapse" id="navbar-collapse">
                            {{ knp_menu_render('main', {'depth': 2}) }}
                            <ul class="nav navbar-nav navbar-right">
                                <!-- Messages Menu -->
                                {# <li class="dropdown messages-menu"
                                    data-frameloader="{{ path('support.dropdown-menu') }}"
                                    data-interval="30000">
                                    <a href="#">
                                        <i class="fa fa-envelope-o"></i>
                                        <span class="visible-xs-inline">&nbsp;Messages</span>
                                    </a>
                                </li> #}
                                <!-- Notifications Menu -->
                                {# <li class="dropdown notifications-menu"
                                    data-frameloader="{{ path('notification.dropdown-menu') }}"
                                    data-interval="30000">
                                    <a href="#">
                                        <i class="fa fa-bell-o"></i>
                                        <span class="visible-xs-inline">&nbsp;Notifications</span>
                                    </a>
                                </li> #}
                                <!-- User Account Menu -->
                                <li class="dropdown user user-menu">
                                    <!-- Menu Toggle Button -->
                                    <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                                        <img src="{{ asset("build/images/user-placeholder.png") }}" class="user-image" alt="User Image">
                                        <!-- hidden-xs hides the username on small devices so only the image appears. -->
                                        <span class="visible-xs-inline">{{  app.user.fullName }}</span>
                                    </a>
                                    <ul class="dropdown-menu">
                                        <!-- The user image in the menu -->
                                        <li class="user-header">
                                            <img src="{{ asset("build/images/user-placeholder.png" ) }}" class="user-image" alt="User Image">
                                            <div>
                                                {% if app.user is defined %}
                                                    <h3>{{ app.user.fullName }}</h3>
                                                    {% if app.user.organization is defined and app.user.organization | length > 0 %}
                                                        <h4>{{ app.user.organization }}</h4>
                                                    {% else %}
                                                        <h4>DATAtourisme</h4>
                                                    {% endif %}
                                                    <small>Membre depuis {{ app.user.created | moment.format('M Y') }}</small>
                                                {% endif %}
                                            </div>
                                        </li>
                                        <!-- Menu Footer-->
                                        <li class="user-footer">
                                            <div class="pull-left">
                                                <a href="{{ path('account.user') }}" class="btn btn-default btn-sm">Mon profil</a>
                                            </div>
                                            <div class="pull-right">
                                                <a href="{{ path('security.logout') }}" class="btn btn-default btn-sm">Déconnexion</a>
                                            </div>
                                        </li>
                                    </ul>
                                </li>
                                <!-- Impersonate -->
                                {% if is_granted('IS_IMPERSONATOR') %}
                                    <li>
                                        <a href="{{ path('user.administrate', {'id': app.user.id, '_switch_user': '_exit'}) }}" title="Arrêter la substitution" data-tooltip data-tooltip-distance="-12" class="bg-red">
                                            <i class="fa fa-user-secret"></i>
                                            <span class="visible-xs-inline">&nbsp;Arrêter la substitution</span>
                                        </a>
                                    </li>
                                {% endif %}
                            </ul>
                        </div>
                        <!-- /.navbar-collapse -->
                    </div>
                    <!-- /.navbar-custom-menu -->
                </div>
                <!-- /.container-fluid -->
            </nav>
            <div class="notify-container">
                {% if _breadcrumb is defined %}
                    {{ macros.breadcrumb(_breadcrumb) }}
                {% endif %}
            </div>
        </header>

        <div class="content-wrapper">
        {% block content_wide %}
            <!-- Full Width Column -->
            <div class="container">
                {% block content %}{% endblock %}
            </div>
            <!-- /.container -->
        {% endblock %}
        </div>
        <!-- /.content-wrapper -->
        {% include "components/footer.html.twig" %}
    </div>
    <!-- ./wrapper -->
{% endblock  %}

templates/_modal.html.twig
{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% import "macros.html.twig" as macros %}

<div class="modal fade {{ block('modal_class')??"" }}" tabindex="-1" role="dialog">
    <div class="modal-dialog {{ block('modal_dialog_class')??"" }}" role="document">
        <div class="modal-content">
            <div class="modal-header {{ block('modal_header_class')??"" }}">
                {% block header %}
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title">{% block title %}{% endblock %}</h4>
                {% endblock %}
            </div>
            <div class="modal-body {{ block('modal_body_class')??"" }}">
                {% block body %}{% endblock %}
            </div>
            <div class="modal-footer">
                {% block footer %}
                    <button type="button" class="btn {% block btn_cancel_class %}btn-default{% endblock %} pull-left" data-dismiss="modal">
                        {% block btn_cancel_label %}Annuler{% endblock %}
                    </button>
                    <button type="button" class="btn {% block btn_validate_class %}btn-primary{% endblock %}" data-submit>
                        {% block btn_validate_label %}Enregistrer{% endblock %}
                    </button>
                {% endblock %}
            </div>
            {% block javascripts %}{% endblock %}
        </div>
    </div>
</div>

templates/_public_layout.html.twig
{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends '_html.html.twig' %}

{% block body %}
    <div class="wrapper">
        <header class="public-header">
            <nav class="navbar navbar-default">
                <div class="container">
                    <div class="navbar-header">
                        <div class="navbar-brand">
                            <a href="/"><img class="navbar-logo" src="{{ asset('build/images/logos/gouvernement.png') }}"></a>
                        </div>
                    </div>

                    {% block navbar %}
                        <ul class="nav navbar-nav navbar-right">
                            <li class="navbar-text">
                                <strong>DATA</strong>tourisme - Plateforme qualité
                            </li>
                        </ul>
                    {% endblock %}
                </div>
            </nav>
        </header>

        <div class="notify-container">
            <div class="content-wrapper">
                {% block content %}{% endblock %}
            </div>
        </div>
        <!-- /.content-wrapper -->
        {% include "components/footer.html.twig" %}
    </div>
    <!-- ./wrapper -->
{% endblock %}

templates/macros.html.twig
{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{# flashes #}
{% macro flashes(attrs={}) %}
    {% for label, flashes in app.session.flashbag.all %}
        {% for flash in flashes %}
            <div class="bootstrap-notify-alert" data-type="{{ label }}">{{ flash|trans|raw|nl2br }}</div>
        {% endfor %}
    {% endfor %}
{% endmacro %}

{# bradcrumb #}
{% macro breadcrumb(paths) %}
    <div class="breadcrumb-container">
        <div class="container">
            <div class="row">
                <div class="col-xs-12">
                    <ol class="breadcrumb">
                        <li><a href="{{ path('home') }}"><i class="fa fa-home"></i> Accueil</a></li>
                        {% for path in paths %}
                            {% set label = path is iterable ? path[0] : path %}
                            {% set route = path is iterable ? path[1] : null %}
                            {% set args = path is iterable and path[2] is defined ? path[2] : [] %}
                            {% if loop.last %}
                                <li class="active">{{ label | trans }}</li>
                            {% else %}
                                <li><a href="{{ route ? path(route, args) : '#' }}">{{ label | trans }}</a></li>
                            {% endif %}
                        {% endfor %}
                    </ol>
                </div>
            </div>
        </div>
    </div>
{% endmacro %}

{# role_label #}
{% macro role_label(role) %}
    {% if 'ADMIN' in role %}
        <i class="fa fa-user-secret"></i>
    {% endif %}
    {{ {
        ROLE_SUPER_ADMIN: "Super administrateur",
        ROLE_ADMIN: "Administrateur",
        ROLE_MANAGER: "Référent",
        ROLE_USER: "Utilisateur"
    }[role] }}
{% endmacro %}